<?php
require_once 'HTTP/OAuth/Consumer.php';

class oauthClient {

    protected $clientId; // Client ID previously registered on rediris.es/blaublau
    protected $clientSecret; // Client Secret previously provided by the server in rediris.es/blaublau
    protected $tcrEndpoint;  //Temporary Credential Request Endpoint
    protected $roaEndpoint; //Resource Owner Authorization Endpoint
    protected $trEndpoint; //Token  Request Endpoint
    protected $prEndpoint; //Protected Resource  Request Endpoint
    protected $method; //Method to send the request: get or post
    protected $scope; //URL where the Resources are accesible
    protected $callback; //Callback URL of your client where the Server come back after authorization

    protected $httpRequest;
    protected $request;

    protected $consumer;

    protected $token;
    protected $secret;
    protected $verifier;

    protected $error;
    protected $timeTempCred;
    protected $timeTokenCred;

    function __construct() {
        $this->tcrEndpoint = "http://localhost/test76.rediris.es/html/ptyoc/servidor/TCREndpoint.php";
        $this->roaEndpoint = "http://localhost/test76.rediris.es/html/ptyoc/servidor/ROAEndpoint.php";
        $this->trEndpoint = "http://localhost/test76.rediris.es/html/ptyoc/servidor/TREndpoint.php";
        $this->method = "GET";
        $this->prEndpoint = "http://localhost/test76.rediris.es/html/ptyoc/servidor/PREndpoint.php";

       $this->httpRequest = new HTTP_Request2;
        $this->httpRequest->setHeader('Accept-Encoding', '.*');
        $this->request = new HTTP_OAuth_Consumer_Request;
        $this->request->accept($this->httpRequest);

        $this->error = null;
         $this->timeTempCred=300; 
    }

    function configure($clientid, $clientSecret, $callback, $time = 300) {
        $this->clientId = $clientid;
        $this->clientSecret = $clientSecret;
        $this->callback = $callback;
        $this->consumer = new HTTP_OAuth_Consumer($this->clientId, $this->clientSecret);
        $this->timeTokenCred=$time;
    }

    // Action before the Authorization of the client.
    function preprocess($scope = "Listas de correo") {
        try {
            $this->consumer->accept($this->request);

            //Configurable params
            $args = array();
            $args['scope'] = $scope;
            $args['timeTemp']=$this->timeTempCred;
            $this->scope= $scope;

            // Gets the Temp Credentials
            $this->consumer->getRequestToken($this->tcrEndpoint, $this->callback, $args, $this->method);

        } catch (HTTP_OAuth_Consumer_Exception_InvalidResponse $e) {
            $this->error = "Respuesta Inválida";
        } catch (Exception $e) {
            $this->error = "Ocurri&oacute; un error al intentar obtener la autorizaci&oacute;n del usuario.";
        }
    }

    // Redirection al ROAEndpoint
    function redirect() {
        header("Location:".$this->consumer->getAuthorizeUrl($this->roaEndpoint));
    }

    function postprocess($token, $verifier, $secret) {
         try {
            $this->verifier=$verifier;
            $this->token=$token;
            $this->secret=$secret;
            $args['scope']=$this->scope;
            $args['timeToken']=$this->timeTokenCred;
            $this->consumer = new HTTP_OAuth_Consumer($this->clientId, $this->clientSecret, $token, $secret);
           $this->consumer->getAccessToken($this->trEndpoint, $verifier,$args, $this->method);
        } catch (Exception $e) {
            $this->error =   "La aplicaci&oacute;n no ha sido autorizada a acceder a los recursos." ;
        }
    }
    //Making the Request of the Resource to the Server
    function getResource() {
        try {
            //Optional params
            $args = array();
            $args['oauth_verifier']=$this->verifier;
            $response = $this->consumer->sendRequest($this->prEndpoint,$args,$this->method);
            return $response->getBody();
        }catch (HTTP_OAuth_Consumer_Exception_InvalidResponse $e) {
            $this->error = "Respuesta inv&aacute;lida.";
        }catch(Exception $e) {
            $this->error = "Ocurri&oacute; un error inesperado.";
        }
    }

   function getError(){
        return $this->error;
    }

    function initParams(){
        
    }

}
?>